"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const stream_1 = require("stream");
class TaskLogWritable extends stream_1.Writable {
    constructor(taskLogger) {
        super();
        this.taskLogger = taskLogger;
        this.buffer = "";
    }
    _write(chunk, _encoding, callback) {
        let prev = 0;
        let curr = 0;
        while (curr < chunk.byteLength) {
            if (chunk[curr] === 13 || (chunk[curr] === 10 && curr - prev > 1)) {
                this.buffer += chunk
                    .slice(prev, curr)
                    .toString()
                    .replace(/^(\r\n|\n|\r)|(\r\n|\n|\r)$/g, "");
                this.flushLine();
                prev = curr;
            }
            curr++;
        }
        this.buffer += chunk
            .slice(prev, curr)
            .toString()
            .replace(/^(\r\n|\n|\r)|(\r\n|\n|\r)$/g, "");
        callback();
    }
    _final(callback) {
        if (this.buffer.length) {
            this.flushLine();
        }
        callback();
    }
    flushLine() {
        this.taskLogger.verbose(this.buffer.trimRight());
        this.buffer = "";
    }
}
exports.TaskLogWritable = TaskLogWritable;
