"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const task_scheduler_1 = require("@microsoft/task-scheduler");
class AdoReporter {
    // not being used since the npm logger is used in its place
    log(entry) { }
    summarize(context) {
        var _a;
        const { measures, tasks } = context;
        const removeColorCodes = new RegExp('\\x1B\[[0-9;]*[A-Za-z]', 'g');
        if (measures.failedTasks && measures.failedTasks.length > 0) {
            const failedPackages = [];
            for (const failedTask of measures.failedTasks) {
                const { pkg, task } = failedTask;
                const taskId = task_scheduler_1.getTaskId(pkg, task);
                const taskLogs = (_a = tasks.get(taskId)) === null || _a === void 0 ? void 0 : _a.logger.getLogs();
                let packageLogs = '';
                if (taskLogs) {
                    packageLogs += `[${pkg} ${task}] `;
                    for (let i = 0; i < taskLogs.length; i += 1) {
                        const _logLine = taskLogs[i].msg.replace(removeColorCodes, '').replace('\n', '');
                        packageLogs += `${_logLine} `;
                    }
                }
                failedPackages.push({ pkg, taskLogs: packageLogs, task });
            }
            const logGroup = [];
            let packagesMessage = `##vso[task.logissue type=error]Your build failed on the following packages => `;
            failedPackages.forEach(({ pkg, task, taskLogs }) => {
                packagesMessage += `[${pkg} ${task}], `;
                if (taskLogs) {
                    logGroup.push(taskLogs);
                }
            });
            packagesMessage += "find the error logs above with the prefix 'ERR!'";
            console.log(packagesMessage);
            console.log(`##vso[task.logissue type=warning]${logGroup.join(' | ')}`);
        }
    }
}
exports.AdoReporter = AdoReporter;
